--- Fl_Image.cxx	2007-05-12 19:06:40.000000000 +0200
+++ Fl_Image.cxx	2007-05-12 19:06:21.000000000 +0200
@@ -186,7 +186,8 @@
 		dx, dy,		// Destination coordinates
 		xerr, yerr,	// X & Y errors
 		xmod, ymod,	// X & Y moduli
-		xstep, ystep;	// X & Y step increments
+		xstep, ystep,	// X & Y step increments
+                line_d;
 
 
   // Figure out Bresenheim step/modulus values...
@@ -194,6 +195,7 @@
   xstep  = (w() / W) * d();
   ymod   = h() % H;
   ystep  = h() / H;
+  line_d = ld() ? ld() : w() * d();
 
   // Allocate memory for the new image...
   new_array = new uchar [W * H * d()];
@@ -202,9 +204,7 @@
 
   // Scale the image using a nearest-neighbor algorithm...
   for (dy = H, sy = 0, yerr = H, new_ptr = new_array; dy > 0; dy --) {
-    for (dx = W, xerr = W, old_ptr = array + sy * (w() * d() + ld());
-	 dx > 0;
-	 dx --) {
+    for (dx = W, xerr = W, old_ptr = array + sy * line_d; dx > 0; dx --) {
       for (c = 0; c < d(); c ++) *new_ptr++ = old_ptr[c];
 
       old_ptr += xstep;
